<?php
/*
-----------------------------------------------------------
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com
  Copyright (c) 2003 osCommerce
  Released under the GNU General Public License
-----------------------------------------------------------
  www.alij.ne.jp Payment Module V.1.0
  alij.php
  Module created by ALIJ(www.alij.co.jp) - 24/12/2008
  Copyright (c) ALIJ
-----------------------------------------------------------
*/

  class alij {
    var $code, $title, $description, $enabled;

// class constructor
    function alij() {
      global $order;

      $this->code = 'alij';
      $this->title = MODULE_PAYMENT_ALIJ_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_ALIJ_TEXT_ADMINTITLE;
      $this->sort_order = MODULE_PAYMENT_ALIJ_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_ALIJ_STATUS == 'True') ? true : false);


      if (MODULE_PAYMENT_ALIJ_ORDER_MAIL == 'True') {
        $this->order_mail = '1';
      } else {
        $this->order_mail = '0';
      }

      if ((int)MODULE_PAYMENT_ALIJ_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_ALIJ_ORDER_STATUS_ID;
      }

      if ((int)MODULE_PAYMENT_ALIJ_ORDER_STATUSOK_ID > 0) {
        $this->order_statusok = MODULE_PAYMENT_ALIJ_ORDER_STATUSOK_ID;
      }

      if ((int)MODULE_PAYMENT_ALIJ_ORDER_STATUSNG_ID > 0) {
        $this->order_statusng = MODULE_PAYMENT_ALIJ_ORDER_STATUSNG_ID;
      }

      if (is_object($order)) $this->update_status();
    
      $this->email_footer = MODULE_PAYMENT_ALIJ_TEXT_EMAIL_FOOTER;
    }

// class methods

    function get_error() {
      global $HTTP_GET_VARS;

      $error = array('title' => MODULE_PAYMENT_ALIJ_TEXT_ERROR,
                     'error' => stripslashes(urldecode($HTTP_GET_VARS['error'])));

      return $error;
    }
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_ALIJ_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_ALIJ_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title,
                   'fields' => array(array('title' => MODULE_PAYMENT_ALIJ_TEXT_PROCESS,'field' => ''))
                  );
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return array('title' => MODULE_PAYMENT_ALIJ_TEXT_DESCRIPTION);
    }

    function process_button() {
      return false;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      global $HTTP_GET_VARS, $order_totals, $insert_id, $order, $payment_class;
      
      $total = ceil($order->info['total']);
      
      if(!isset($HTTP_GET_VARS['CustomerId'])){	//Ѳ̤
        $array_count= count($order_totals);
        $creditcard = 'https://credit.alij.ne.jp/service/credit/input.html' . 
		      '?SiteId='.MODULE_PAYMENT_ALIJ_SITE_ID.//̤ˤ
		      '&SitePass='.MODULE_PAYMENT_ALIJ_SITE_PASS.//̤ˤ
		      '&insid=' . $insert_id .
		      '&notified=' . $this->order_mail .
		      '&Amount=' . $total .
		      '&tel=' . preg_replace('/[^0-9]/','',$order->billing['telephone']) .
		      '&mail=' . $order->customer['email_address'] .
		      '&sessid=' . session_id() .
		      '&languages_id='.$_SESSION['languages_id'] .
		      '&mode=ALIJreturn'.		      
		      '&TransactionId=' . $insert_id;
        tep_redirect($creditcard);
      }
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_ALIJ_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('쥸åȥɷѤͭˤ', 'MODULE_PAYMENT_ALIJ_STATUS', 'True', '쥸åȥɤˤʧդޤ?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now());");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ID', 'MODULE_PAYMENT_ALIJ_SITE_ID', '', 'IDϤƤ', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PASS', 'MODULE_PAYMENT_ALIJ_SITE_PASS', '', 'passϤƤ', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ɽ', 'MODULE_PAYMENT_ALIJ_SORT_ORDER', '0', 'ɽǤޤۤɾ̤ɽޤ', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Ŭϰ', 'MODULE_PAYMENT_ALIJ_ZONE', '0', 'Ŭϰ򤹤ȡ򤷤ϰΤߤѲǽȤʤޤ', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('ʸơ', 'MODULE_PAYMENT_ALIJ_ORDER_STATUS_ID', '0', 'ꤷơŬѤޤ', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('ơ', 'MODULE_PAYMENT_ALIJ_ORDER_STATUSOK_ID', '0', 'ꤷơŬѤޤ', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Ѽԥơ', 'MODULE_PAYMENT_ALIJ_ORDER_STATUSNG_ID', '0', 'ꤷơѼԻŬѤޤ', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('ѷ̤ܵҤ˥᡼', 'MODULE_PAYMENT_ALIJ_ORDER_MAIL', 'True', 'ѷ̤ܵҤ˥᡼Τޤ?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now());");

      $language_query = tep_db_query("select languages_id from " . TABLE_LANGUAGES . " where name = 'Japanese'");
      $insert_languages_id = tep_db_fetch_array($language_query);
      $insert_language_id = $insert_languages_id["languages_id"];
      tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('97',$insert_language_id , '̤֤Ǥ')");
      tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('98',$insert_language_id , 'Ѥλޤ')");
      tep_db_query("insert into " . TABLE_ORDERS_STATUS . "(orders_status_id, language_id, orders_status_name) values ('99',$insert_language_id , 'ѤԤޤ')");


    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
      tep_db_query("delete from " . TABLE_ORDERS_STATUS . " where orders_status_id=97");
      tep_db_query("delete from " . TABLE_ORDERS_STATUS . " where orders_status_id=98");
      tep_db_query("delete from " . TABLE_ORDERS_STATUS . " where orders_status_id=99");
    }

    function keys() {
      return array('MODULE_PAYMENT_ALIJ_STATUS','MODULE_PAYMENT_ALIJ_SITE_ID','MODULE_PAYMENT_ALIJ_SITE_PASS', 'MODULE_PAYMENT_ALIJ_ZONE', 'MODULE_PAYMENT_ALIJ_ORDER_MAIL', 'MODULE_PAYMENT_ALIJ_ORDER_STATUS_ID', 'MODULE_PAYMENT_ALIJ_ORDER_STATUSOK_ID', 'MODULE_PAYMENT_ALIJ_ORDER_STATUSNG_ID', 'MODULE_PAYMENT_ALIJ_SORT_ORDER');
    }
  }
?>
